Wt: Wt::WLink Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
Wt::WLink Class Reference

A value class that defines a hyperlink target. More...

List of all members.

## Public Types
enum | Type { Url, Resource, InternalPath }
| An enumeration for a link type. More...
## Public Member Functions
| WLink ()
| Default constructor.
| WLink (const char *url)
| Creates a link to a (static) URL.
| WLink (const std::string &url)
| Creates a link to a (static) URL.
| WLink (Type type, const std::string &value)
| Creates a link to a (static) URL or an internal path.
| WLink (WResource *resource)
| Creates a link to a resource.
Type | type () const
| Returns the link type.
bool | isNull () const
| Returns whether the link is unspecified.
void | setUrl (const std::string &url)
| Sets the link URL.
std::string | url () const
| Returns the link URL.
void | setResource (WResource *resource)
| Sets the link resource.
WResource * | resource () const
| Returns the link resource.
void | setInternalPath (const WString &internalPath)
| Sets the link internal path.
WString | internalPath () const
| Returns the internal path.
bool | operator== (const WLink &other) const
| Comparison operator.
bool | operator!= (const WLink &other) const
| Comparison operator.

## Detailed Description

A value class that defines a hyperlink target.

This class abstracts a link target. Depending on the context, it may reference a URL, a dynamic resource, or (for certain usages) an internal path.

See also:
  WAnchor, WImage, WMediaPlayer, WPopupMenuItem, WPushButton

## Member Enumeration Documentation

enum Wt::WLink::Type

An enumeration for a link type.

See also:
  type()

Enumerator:

  Url | A static URL.
  Resource | A dynamic resource.
  InternalPath | An internal path.

## Constructor & Destructor Documentation

Wt::WLink::WLink | ( |  | ) |

Default constructor.

This constructs a null link.

Wt::WLink::WLink | ( | const char * | url | ) |

Creates a link to a (static) URL.

See also:
  setUrl()

Wt::WLink::WLink | ( | const std::string & | url | ) |

Creates a link to a (static) URL.

See also:
  setUrl()

Wt::WLink::WLink | ( | Type | type,
|  | const std::string & | value
| ) |  |

Creates a link to a (static) URL or an internal path.

Using this constructor, you can create a link to a static URL (`type` == WLink::Url) or an internal path (`type` == WLink::InternalPath). For an internal path, the `value` will be interpreted as a UTF8 encoded string.

See also:
  setUrl(), setInternalPath()

Wt::WLink::WLink | ( | WResource * | resource | ) |

Creates a link to a resource.

Ownership of the `resource` is not transferred to the link (or to the widget that deals with it), to allow resources to be shared.

See also:
  setResource()

## Member Function Documentation

WString Wt::WLink::internalPath | ( |  | ) | const

Returns the internal path.

This returns the internal path perviously set using setInternalPath(), or an empty string otherwise.

See also:
  setInternalPath().

bool Wt::WLink::isNull | ( |  | ) | const

Returns whether the link is unspecified.

A null link is a link created using the default constructor and points to nowhere.

See also:
  WLink()

WResource * Wt::WLink::resource | ( |  | ) | const

Returns the link resource.

This returns the resource previously set using setResource(), or `0`.

See also:
  setResource()

void Wt::WLink::setInternalPath | ( | const WString & | internalPath | ) |

Sets the link internal path.

This points the link to the given internal path.

void Wt::WLink::setResource | ( | WResource * | resource | ) |

Sets the link resource.

This sets the type to WLink::Resource.

Ownership of the `resource` is not transferred to the link (or to the widget that deals with it), to allow resources to be shared.

void Wt::WLink::setUrl | ( | const std::string & | url | ) |

Sets the link URL.

This sets the type to WLink::Url.

Type Wt::WLink::type | ( |  | ) | const

Returns the link type.

The type is implicitly set depending on the constructor or after calling setUrl(), setResource() or setInternalPath().

The default type for a null link is WLink::Url.

std::string Wt::WLink::url | ( |  | ) | const

Returns the link URL.

The return value is the URL set by setUrl(), the resource URL of the resource set using setResource(), or the canonical URL of an internal path within the current application context.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator